package Tetris;

import java.awt.Color;
import java.awt.Graphics;
import java.util.ArrayList;
import java.util.Random;
import java.util.Iterator;

import javax.swing.JLabel;

public class Block extends JLabel
{
	int[][][] block_array =
		{
			{//OBlock[0]
				{0, 0, 0, 0},
				{0, 0, 0, 0},
				{0, 1, 1, 0},
				{0, 1, 1, 0}
			},
			{//LBlock[1]
				{0, 0, 0, 0},
				{0, 1, 0, 0},
				{0, 1, 0, 0},
				{0, 1, 1, 0}
			},
			{//JBlock[2]
				{0, 0, 0, 0},
				{0, 0, 0, 1},
				{0, 0, 0, 1},
				{0, 0, 1, 1}
			},
			{//TBlock[3]
				{0, 0, 0, 0},
				{0, 0, 0, 0},
				{0, 1, 1, 1},
				{0, 0, 1, 0}
			},
			{//IBlock[4]
				{0, 1, 0, 0},
				{0, 1, 0, 0},
				{0, 1, 0, 0},
				{0, 1, 0, 0}
			},
			{//ZBlock[5]
				{0, 0, 0, 0},
				{0, 0, 0, 0},
				{0, 1, 1, 0},
				{0, 0, 1, 1}
			},
			{//SBlock[6]
				{0, 0, 0, 0},
				{0, 0, 0, 0},
				{0, 0, 1, 1},
				{0, 1, 1, 0}
			}	
		};
	int array_size = 4;//array size
	int array_index = 0;// select index
	int[][] array = new int[array_size][array_size];//selected array
	Random ran = new Random();
	int x = 9;//block X-coordinate
	int y = 0;//block Y-coordinate
	Color color = null;//block color
	boolean flag = true;//rotate flag

	void Rotate()//rotate
	{	
		int[][] temp = new int[array_size][array_size];
		
		switch(array_index)
		{
		case 0://OBlock No rotate
			break;
		case 1://L, J, TBlock 90ºrotate 4times
		case 2:
		case 3:
			for(int i = 0; i < array_size; i++)
				for(int j = 0; j < array_size; j++)
				{
					temp[j][i] = array[i][j];
					array[i][j] = 0;
				}
				
			for(int i = 0; i < array_size; i++)
				for(int j = 0; j < array_size; j++)
					if(temp[i][j] == 1 && i < 2)
						array[2+Math.abs(i-2)][j] = temp[i][j];
					else if(temp[i][j] == 1)
						array[2-Math.abs(i-2)][j] = temp[i][j];
			
			break;
		case 4://I, Z, SBlock 90ºrotate 2times
		case 5:
		case 6:
			if(flag)//rotate check
			{		
				for(int i = 0; i < array_size; i++)
					for(int j = 0; j < array_size; j++)
					{
						temp[j][i] = array[i][j];
						array[i][j] = 0;
					}
					
				for(int i = 0; i < array_size; i++)
					for(int j = 0; j < array_size; j++)
						if(temp[i][j] == 1 && i < 2)
							array[2+Math.abs(i-2)][j] = temp[i][j];
						else if(temp[i][j] == 1)
							array[2-Math.abs(i-2)][j] = temp[i][j];
				
				flag = false;
			}
			else
			{
				for(int i = 0; i < array_size; i++)
					for(int j = 0; j < array_size; j++)
						array[i][j] = block_array[array_index][i][j];

				flag = true;
			}
		}	
	}
	
	public Block() 
	{
		// TODO Auto-generated constructor stub
		
		array_index = ran.nextInt(7);
//		array_index = *;//test(All *Block)
	
		for(int i = 0; i < array_size; i++)
			for(int j = 0; j < array_size; j++)//choice block
				array[i][j] = block_array[array_index][i][j];

		switch(array_index)
		{
		case 0://OBlock[0]
			color = Color.blue;
			break;
		case 1://LBlock[1]
			color = Color.magenta;
			break;
		case 2://JBlock[2]
			color = Color.yellow;
			break;
		case 3://TBlock[3]
			color = Color.green;
			break;
		case 4://IBlock[4]
			color = Color.red;
			break;
		case 5://ZBlock[5]
			color = Color.orange;
			break;
		case 6://SBlock[6]
			color = Color.cyan;
			break;
		}
	}
}